# __init__.py for computerjanitorapp
# Copyright (C) 2008, 2009  Canonical, Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


VERSION = "1.13.3"


# Set up gettext. This needs to be before the import statements below
# so that if any modules call it right after importing, they find
# setup_gettext.

def setup_gettext():
    """Set up gettext for a module.

    Return a method to be used for looking up translations. Usage:

      import computerjanitorapp
      _ = computerjanitorapp.setup_gettext()

    """

    import gettext
    import os

    domain = 'computerjanitor'
    localedir = os.environ.get('LOCPATH', None)
    t = gettext.translation(domain, localedir=localedir, fallback=True)
    return t.ugettext


from app import Application
from ui import UserInterface
from ui_cli import CommandLineUserInterface
from ui_gtk import GtkUserInterface
from state import State
from terminalsize import get_terminal_size
